summaryrefslogtreecommitdiffstats
path: root/system
diff options
context:
space:
mode:
author Andrew Clemons <andrew.clemons@gmail.com>2019-06-15 06:52:37 +0700
committer Willy Sudiarto Raharjo <willysr@slackbuilds.org>2019-06-15 06:52:37 +0700
commit5760b351ea46edb7fcaeedc50b40d44618da9991 (patch)
tree50b486855b448e3bdc5e47846c9ee88947625674 /system
parentcc1f5a2d10b93f346ce7aed80ae1f6c036d49744 (diff)
downloadslackbuilds-5760b351ea46edb7fcaeedc50b40d44618da9991.tar.gz
slackbuilds-5760b351ea46edb7fcaeedc50b40d44618da9991.tar.xz
system/binfmt-support: Added (Support scripts).
Signed-off-by: Willy Sudiarto Raharjo <willysr@slackbuilds.org>
Diffstat (limited to 'system')
-rw-r--r--system/binfmt-support/README26
-rw-r--r--system/binfmt-support/binfmt-support.SlackBuild115
-rw-r--r--system/binfmt-support/binfmt-support.info10
-rw-r--r--system/binfmt-support/doinst.sh22
-rw-r--r--system/binfmt-support/slack-desc19
5 files changed, 192 insertions, 0 deletions
diff --git a/system/binfmt-support/README b/system/binfmt-support/README
new file mode 100644
index 0000000000..69d913b229
--- /dev/null
+++ b/system/binfmt-support/README
@@ -0,0 +1,26 @@
+binfmt-support
+
+The binfmt_misc kernel module, contained in versions 2.1.43 and later of the
+Linux kernel, allows system administrators to register interpreters for
+various binary formats based on a magic number or their file extension, and
+cause the appropriate interpreter to be invoked whenever a matching file is
+executed. Think of it as a more flexible version of the #! executable
+interpreter mechanism.
+
+binfmt-support provides an update-binfmts script with which package
+maintainers can register interpreters to be used with this module without
+having to worry about writing their own init.d scripts, and which sysadmins
+can use for a slightly higher-level interface to this module.
+
+To have binfmt-support start and stop with your host,
+add to /etc/rc.d/rc.local:
+
+ if [ -x /etc/rc.d/rc.binfmt-support ]; then
+ /etc/rc.d/rc.binfmt-support start
+ fi
+
+and to /etc/rc.d/rc.local_shutdown (creating it if needed):
+
+ if [ -x /etc/rc.d/rc.binfmt-support ]; then
+ /etc/rc.d/rc.binfmt-support stop
+ fi
diff --git a/system/binfmt-support/binfmt-support.SlackBuild b/system/binfmt-support/binfmt-support.SlackBuild
new file mode 100644
index 0000000000..3471378594
--- /dev/null
+++ b/system/binfmt-support/binfmt-support.SlackBuild
@@ -0,0 +1,115 @@
+#!/bin/sh
+
+# Slackware build script for binfmt-support
+
+# Copyright 2019 Andrew Clemons, Wellington New Zealand
+# All rights reserved.
+#
+# Redistribution and use of this script, with or without modification, is
+# permitted provided that the following conditions are met:
+#
+# 1. Redistributions of this script must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR "AS IS" AND ANY EXPRESS OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
+# EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
+# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
+# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
+# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
+# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+PRGNAM=binfmt-support
+VERSION=${VERSION:-2.2.0}
+BUILD=${BUILD:-1}
+TAG=${TAG:-_SBo}
+
+if [ -z "$ARCH" ]; then
+ case "$( uname -m )" in
+ i?86) ARCH=i586 ;;
+ arm*) ARCH=arm ;;
+ *) ARCH=$( uname -m ) ;;
+ esac
+fi
+
+CWD=$(pwd)
+TMP=${TMP:-/tmp/SBo}
+PKG=$TMP/package-$PRGNAM
+OUTPUT=${OUTPUT:-/tmp}
+
+if [ "$ARCH" = "i586" ]; then
+ SLKCFLAGS="-O2 -march=i586 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "i686" ]; then
+ SLKCFLAGS="-O2 -march=i686 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "x86_64" ]; then
+ SLKCFLAGS="-O2 -fPIC"
+ LIBDIRSUFFIX="64"
+else
+ SLKCFLAGS="-O2"
+ LIBDIRSUFFIX=""
+fi
+
+set -e
+
+rm -rf $PKG
+mkdir -p $TMP $PKG $OUTPUT
+cd $TMP
+rm -rf $PRGNAM-$VERSION
+tar xvf $CWD/"$PRGNAM"_"$VERSION".orig.tar.gz
+cd $PRGNAM-$VERSION
+chown -R root:root .
+find -L . \
+ \( -perm 777 -o -perm 775 -o -perm 750 -o -perm 711 -o -perm 555 \
+ -o -perm 511 \) -exec chmod 755 {} \; -o \
+ \( -perm 666 -o -perm 664 -o -perm 640 -o -perm 600 -o -perm 444 \
+ -o -perm 440 -o -perm 400 \) -exec chmod 644 {} \;
+
+CFLAGS="$SLKCFLAGS" \
+CXXFLAGS="$SLKCFLAGS" \
+./configure \
+ --prefix=/usr \
+ --libdir=/usr/lib${LIBDIRSUFFIX} \
+ --sysconfdir=/etc \
+ --localstatedir=/var \
+ --mandir=/usr/man \
+ --docdir=/usr/doc/$PRGNAM-$VERSION \
+ --build=$ARCH-slackware-linux \
+ --enable-sysvinit \
+ --disable-upstart \
+ --disable-systemd
+
+make
+make install DESTDIR=$PKG
+
+mv $PKG/etc/init.d $PKG/etc/rc.d
+mv $PKG/etc/rc.d/binfmt-support $PKG/etc/rc.d/rc.binfmt-support
+
+sed -i 's/init\.d/rc.d/g' $PKG/etc/rc.d/rc.binfmt-support
+sed -i '/^NAME=/s/=/=rc./' $PKG/etc/rc.d/rc.binfmt-support
+
+chmod 0644 $PKG/etc/rc.d/rc.binfmt-support
+mv $PKG/etc/rc.d/rc.binfmt-support $PKG/etc/rc.d/rc.binfmt-support.new
+
+find $PKG -print0 | xargs -0 file | grep -e "executable" -e "shared object" | grep ELF \
+ | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null || true
+
+find $PKG/usr/man -type f -exec gzip -9 {} \;
+for i in $( find $PKG/usr/man -type l ) ; do ln -s $( readlink $i ).gz $i.gz ; rm $i ; done
+
+mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
+cp -a \
+ COPYING ChangeLog-2013 NEWS \
+ $PKG/usr/doc/$PRGNAM-$VERSION
+cat $CWD/$PRGNAM.SlackBuild > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild
+
+mkdir -p $PKG/install
+cat $CWD/slack-desc > $PKG/install/slack-desc
+cat $CWD/doinst.sh > $PKG/install/doinst.sh
+
+cd $PKG
+/sbin/makepkg -l y -c n $OUTPUT/$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.${PKGTYPE:-tgz}
diff --git a/system/binfmt-support/binfmt-support.info b/system/binfmt-support/binfmt-support.info
new file mode 100644
index 0000000000..37201e7fb5
--- /dev/null
+++ b/system/binfmt-support/binfmt-support.info
@@ -0,0 +1,10 @@
+PRGNAM="binfmt-support"
+VERSION="2.2.0"
+HOMEPAGE="http://binfmt-support.nongnu.org/"
+DOWNLOAD="http://deb.debian.org/debian/pool/main/b/binfmt-support/binfmt-support_2.2.0.orig.tar.gz"
+MD5SUM="94e715eb371f0b8823cd7a24692cda20"
+DOWNLOAD_x86_64=""
+MD5SUM_x86_64=""
+REQUIRES="man-db"
+MAINTAINER="Andrew Clemons"
+EMAIL="andrew.clemons@gmail.com"
diff --git a/system/binfmt-support/doinst.sh b/system/binfmt-support/doinst.sh
new file mode 100644
index 0000000000..36b62594cd
--- /dev/null
+++ b/system/binfmt-support/doinst.sh
@@ -0,0 +1,22 @@
+config() {
+ NEW="$1"
+ OLD="$(dirname $NEW)/$(basename $NEW .new)"
+ if [ ! -r $OLD ]; then
+ mv $NEW $OLD
+ elif [ "$(cat $OLD | md5sum)" = "$(cat $NEW | md5sum)" ]; then
+ rm $NEW
+ fi
+}
+
+preserve_perms() {
+ NEW="$1"
+ OLD="$(dirname $NEW)/$(basename $NEW .new)"
+ if [ -e $OLD ]; then
+ cp -a $OLD ${NEW}.incoming
+ cat $NEW > ${NEW}.incoming
+ mv ${NEW}.incoming $NEW
+ fi
+ config $NEW
+}
+
+preserve_perms etc/rc.d/rc.binfmt-support.new
diff --git a/system/binfmt-support/slack-desc b/system/binfmt-support/slack-desc
new file mode 100644
index 0000000000..1d7129136e
--- /dev/null
+++ b/system/binfmt-support/slack-desc
@@ -0,0 +1,19 @@
+# HOW TO EDIT THIS FILE:
+# The "handy ruler" below makes it easier to edit a package description.
+# Line up the first '|' above the ':' following the base package name, and
+# the '|' on the right side marks the last column you can put a character in.
+# You must make exactly 11 lines for the formatting to be correct. It's also
+# customary to leave one space after the ':' except on otherwise blank lines.
+
+ |-----handy-ruler------------------------------------------------------|
+binfmt-support: binfmt-support (script to register interpreters with binfmt_misc)
+binfmt-support:
+binfmt-support: binfmt-support provides an update-binfmts script with which
+binfmt-support: package maintainers can register interpreters to be used with
+binfmt-support: this module without having to worry about writing their own
+binfmt-support: init.d scripts, and which sysadmins can use for a slightly
+binfmt-support: higher-level interface to this module.
+binfmt-support:
+binfmt-support:
+binfmt-support: https://nongnu.org/binfmt-support/
+binfmt-support: